// InetSessAsy.cpp: implementation of the CInetSessAsy class.
//
//////////////////////////////////////////////////////////////////////

#include "stdafx.h"

#include "URLChecker.h"
#include "InetSessAsy.h"

#ifdef _DEBUG
#undef THIS_FILE
static char THIS_FILE[]=__FILE__;
#define new DEBUG_NEW
#endif

INETSTATUS CInetSessAsy::m_inetStatus[]=
{
	INTERNET_STATUS_RESOLVING_NAME, _T("Looking up the IP address of the name contained in lpvStatusInformation."), 
	INTERNET_STATUS_NAME_RESOLVED, _T("Successfully found the IP address of the name contained in lpvStatusInformation."), 
	INTERNET_STATUS_CONNECTING_TO_SERVER, _T("Connecting to the socket address (SOCKADDR) pointed to by lpvStatusInformation."), 
	INTERNET_STATUS_CONNECTED_TO_SERVER, _T("Successfully connected to the socket address (SOCKADDR) pointed to by lpvStatusInformation."), 
	INTERNET_STATUS_SENDING_REQUEST, _T("Sending the information request to the server. The lpvStatusInformation parameter is NULL."), 
	INTERNET_STATUS_REQUEST_SENT, _T("Successfully sent the information request to the server. The lpvStatusInformation parameter is NULL."), 
	INTERNET_STATUS_RECEIVING_RESPONSE, _T("Waiting for the server to respond to a request. The lpvStatusInformation parameter is NULL."), 
	INTERNET_STATUS_RESPONSE_RECEIVED, _T("Successfully received a response from the server. The lpvStatusInformation parameter is NULL."), 
	INTERNET_STATUS_CLOSING_CONNECTION, _T("Closing the connection to the server. The lpvStatusInformation parameter is NULL."), 
	INTERNET_STATUS_CONNECTION_CLOSED, _T("Successfully closed the connection to the server. The lpvStatusInformation parameter is NULL."), 
	INTERNET_STATUS_HANDLE_CREATED, _T("Used by the Win32 API function InternetConnect to indicate that it has created the new handle. This lets the application call the Win32 function InternetCloseHandle from another thread if the connect is taking too long. See the ActiveX SDK for more information about these functions."), 
	INTERNET_STATUS_HANDLE_CLOSING, _T("Successfully terminated this handle value."), 
	INTERNET_STATUS_REQUEST_COMPLETE, _T("Successfully completed the asynchronous operation. See the CInternetSession constructor for details on INTERNET_FLAG_ASYNC.The lpvStatusInformation parameter points at an INTERNET_ASYNC_RESULT structure, and dwStatusInformationLength contains the final completion status of the asynchronous function. If this is ERROR_INTERNET_EXTENDED_ERROR, the application can retrieve the server error information by using the Win32 function InternetGetLastResponseInfo. See the ActiveX SDK for more information about this function.") 
};

INETSTATUS CInetSessAsy::m_inetErrors[]=
{
	ERROR_FTP_DROPPED, _T("The FTP operation was not completed because the session was aborted."), 
	ERROR_FTP_NO_PASSIVE_MODE, _T("Passive mode is not available on the server."), 
	ERROR_FTP_TRANSFER_IN_PROGRESS, _T("The requested operation cannot be made on the FTP session handle because an operation is already in progress."), 
	ERROR_GOPHER_ATTRIBUTE_NOT_FOUND, _T("The requested attribute could not be located."), 
	ERROR_GOPHER_DATA_ERROR, _T("An error was detected while receiving data from the Gopher server."), 
	ERROR_GOPHER_END_OF_DATA, _T("The end of the data has been reached."), 
	ERROR_GOPHER_INCORRECT_LOCATOR_TYPE, _T("The type of the locator is not correct for this operation."), 
	ERROR_GOPHER_INVALID_LOCATOR, _T("The supplied locator is not valid."), 
	ERROR_GOPHER_NOT_FILE, _T("The request must be made for a file locator."), 
	ERROR_GOPHER_NOT_GOPHER_PLUS, _T("The requested operation can be made only against a Gopher+ server, or with a locator that specifies a Gopher+ operation."), 
	ERROR_GOPHER_PROTOCOL_ERROR, _T("An error was detected while parsing data returned from the Gopher server."), 
	ERROR_GOPHER_UNKNOWN_LOCATOR, _T("The locator type is unknown."), 
	ERROR_HTTP_COOKIE_DECLINED, _T("The HTTP cookie was declined by the server."), 
	ERROR_HTTP_COOKIE_NEEDS_CONFIRMATION, _T("The HTTP cookie requires confirmation."), 
	ERROR_HTTP_DOWNLEVEL_SERVER, _T("The server did not return any headers."), 
	ERROR_HTTP_HEADER_ALREADY_EXISTS, _T("The header could not be added because it already exists."), 
	ERROR_HTTP_HEADER_NOT_FOUND, _T("The requested header could not be located."), 
	ERROR_HTTP_INVALID_HEADER, _T("The supplied header is invalid."), 
	ERROR_HTTP_INVALID_QUERY_REQUEST, _T("The request made to HttpQueryInfo is invalid."), 
	ERROR_HTTP_INVALID_SERVER_RESPONSE, _T("The server response could not be parsed."), 
	ERROR_HTTP_NOT_REDIRECTED, _T("The HTTP request was not redirected."), 
	ERROR_HTTP_REDIRECT_FAILED, _T("The redirection failed because either the scheme changed (for example, HTTP to FTP) or all attempts made to redirect failed (default is five attempts)."), 
	ERROR_HTTP_REDIRECT_NEEDS_CONFIRMATION, _T("The redirection requires user confirmation."), 
	ERROR_INTERNET_ASYNC_THREAD_FAILED, _T("The application could not start an asynchronous thread."), 
	ERROR_INTERNET_BAD_AUTO_PROXY_SCRIPT, _T("There was an error in the automatic proxy configuration script."), 
	ERROR_INTERNET_BAD_OPTION_LENGTH, _T("The length of an option supplied to InternetQueryOption or InternetSetOption is incorrect for the type of option specified."), 
	ERROR_INTERNET_BAD_REGISTRY_PARAMETER, _T("A required registry value was located but is an incorrect type or has an invalid value."), 
	ERROR_INTERNET_CANNOT_CONNECT, _T("The attempt to connect to the server failed."), 
	ERROR_INTERNET_CHG_POST_IS_NON_SECURE, _T("The application is posting and attempting to change multiple lines of text on a server that is not secure."), 
	ERROR_INTERNET_CLIENT_AUTH_CERT_NEEDED, _T("The server is requesting client authentication."), 
	ERROR_INTERNET_CLIENT_AUTH_NOT_SETUP, _T("Client authorization is not set up on this computer."), 
	ERROR_INTERNET_CONNECTION_ABORTED, _T("The connection with the server has been terminated."), 
	ERROR_INTERNET_CONNECTION_RESET, _T("The connection with the server has been reset."), 
	ERROR_INTERNET_DIALOG_PENDING, _T("Another thread has a password dialog box in progress."), 
	ERROR_INTERNET_DISCONNECTED, _T("The Internet connection has been lost."), 
	ERROR_INTERNET_EXTENDED_ERROR, _T("An extended error was returned from the server. This is typically a string or buffer containing a verbose error message. Call InternetGetLastResponseInfo to retrieve the error text."), 
	ERROR_INTERNET_FAILED_DUETOSECURITYCHECK, _T("The function failed due to a security check."), 
	ERROR_INTERNET_FORCE_RETRY, _T("The Win32 Internet function needs to redo the request."), 
	ERROR_INTERNET_HANDLE_EXISTS, _T("The request failed because the handle already exists."), 
	ERROR_INTERNET_HTTP_TO_HTTPS_ON_REDIR, _T("The application is moving from a non-SSL to an SSL connection because of a redirect."), 
	ERROR_INTERNET_HTTPS_TO_HTTP_ON_REDIR, _T("The application is moving from an SSL to an non-SSL connection because of a redirect."), 
	ERROR_INTERNET_HTTPS_HTTP_SUBMIT_REDIR, _T("The data being submitted to an SSL connection is being redirected to a non-SSL connection."), 
	ERROR_INTERNET_INCORRECT_FORMAT, _T("The format of the request is invalid."), 
	ERROR_INTERNET_INCORRECT_HANDLE_STATE, _T("The requested operation cannot be carried out because the handle supplied is not in the correct state."), 
	ERROR_INTERNET_INCORRECT_HANDLE_TYPE, _T("The type of handle supplied is incorrect for this operation."), 
	ERROR_INTERNET_INCORRECT_PASSWORD, _T("The request to connect and log on to an FTP server could not be completed because the supplied password is incorrect."), 
	ERROR_INTERNET_INCORRECT_USER_NAME, _T("The request to connect and log on to an FTP server could not be completed because the supplied user name is incorrect."), 
	ERROR_INTERNET_INSERT_CDROM, _T("The request requires a CD-ROM to be inserted in the CD-ROM drive to locate the resource requested."), 
	ERROR_INTERNET_INTERNAL_ERROR, _T("An internal error has occurred."), 
	ERROR_INTERNET_INVALID_CA, _T("The function is unfamiliar with the Certificate Authority that generated the server's certificate."), 
	ERROR_INTERNET_INVALID_OPERATION, _T("The requested operation is invalid."), 
	ERROR_INTERNET_INVALID_OPTION, _T("A request to InternetQueryOption or InternetSetOption specified an invalid option value."), 
	ERROR_INTERNET_INVALID_PROXY_REQUEST, _T("The request to the proxy was invalid."), 
	ERROR_INTERNET_INVALID_URL, _T("The URL is invalid."), 
	ERROR_INTERNET_ITEM_NOT_FOUND, _T("The requested item could not be located."), 
	ERROR_INTERNET_LOGIN_FAILURE, _T("The request to connect and log on to an FTP server failed."), 
	ERROR_INTERNET_MIXED_SECURITY, _T("The content is not entirely secure. Some of the content being viewed may have come from unsecured servers."), 
	ERROR_INTERNET_NAME_NOT_RESOLVED, _T("The server name could not be resolved."), 
	ERROR_INTERNET_NEED_UI, _T("A user interface or other blocking operation has been requested."), 
	ERROR_INTERNET_NO_CALLBACK, _T("An asynchronous request could not be made because a callback function has not been set."), 
	ERROR_INTERNET_NO_CONTEXT, _T("An asynchronous request could not be made because a zero context value was supplied."), 
	ERROR_INTERNET_NO_DIRECT_ACCESS, _T("Direct network access cannot be made at this time."), 
	ERROR_INTERNET_NOT_PROXY_REQUEST, _T("The request cannot be made via a proxy."), 
	ERROR_INTERNET_OPERATION_CANCELLED, _T("The operation was canceled, usually because the handle on which the request was operating was closed before the operation completed."), 
	ERROR_INTERNET_OPTION_NOT_SETTABLE, _T("The requested option cannot be set, only queried."), 
	ERROR_INTERNET_OUT_OF_HANDLES, _T("No more handles could be generated at this time."), 
	ERROR_INTERNET_POST_IS_NON_SECURE, _T("The application is posting data to a sever that is not secure."), 
	ERROR_INTERNET_PROTOCOL_NOT_FOUND, _T("The requested protocol could not be located."), 
	ERROR_INTERNET_PROXY_SERVER_UNREACHABLE, _T("The designated proxy server cannot be reached."), 
	ERROR_INTERNET_REDIRECT_SCHEME_CHANGE, _T("The function could not handle the redirection, because the scheme changed (for example, HTTP to FTP)."), 
	ERROR_INTERNET_REGISTRY_VALUE_NOT_FOUND, _T("A required registry value could not be located."), 
	ERROR_INTERNET_REQUEST_PENDING, _T("The required operation could not be completed because one or more requests are pending."), 
	ERROR_INTERNET_RETRY_DIALOG, _T("The dialog box should be retried."), 
	ERROR_INTERNET_SEC_CERT_CN_INVALID, _T("SSL certificate common name (host name field) is incorrectfor example, if you entered www.server.com and the common name on the certificate says www.different.com."), 
	ERROR_INTERNET_SEC_CERT_DATE_INVALID, _T("SSL certificate date that was received from the server is bad. The certificate is expired."), 
	ERROR_INTERNET_SEC_CERT_REVOKED, _T("SSL certificate was revoked."), 
	ERROR_INTERNET_SEC_INVALID_CERT, _T("SSL certificate is invalid."), 
	ERROR_INTERNET_SECURITY_CHANNEL_ERROR, _T("The application experienced an internal error loading the SSL libraries."), 
	ERROR_INTERNET_SERVER_UNREACHABLE, _T("The Web site or server indicated is unreachable."), 
	ERROR_INTERNET_SHUTDOWN, _T("The Win32 Internet function support is being shut down or unloaded."), 
	ERROR_INTERNET_TCPIP_NOT_INSTALLED, _T("The required protocol stack is not loaded and the application cannot start WinSock."), 
	ERROR_INTERNET_TIMEOUT, _T("The request has timed out."), 
	ERROR_INTERNET_UNABLE_TO_CACHE_FILE, _T("The function was unable to cache the file."), 
	ERROR_INTERNET_UNABLE_TO_DOWNLOAD_SCRIPT, _T("The automatic proxy configuration script could not be downloaded. The INTERNET_FLAG_MUST_CACHE_REQUEST flag was set."), 
	ERROR_INTERNET_UNRECOGNIZED_SCHEME, _T("The URL scheme could not be recognized, or is not supported."), 
	ERROR_INVALID_HANDLE, _T("The handle that was passed to the API has been either invalidated or closed. (Win32 error code)"), 
	ERROR_NO_MORE_FILES, _T("No more files have been found. (Win32 error code)"), 
	ERROR_NO_MORE_ITEMS, _T("No more items have been found. (Win32 error code)"), 
	INTERNET_ERROR_BASE, _T("Not an error code. Base value used for the Internet error codes.") 
};

/* Hm...???
	ERROR_INTERNET_FORTEZZA_LOGIN_NEEDED, _T("The requested resource requires Fortezza authentication."), 
	ERROR_INTERNET_LOGIN_FAILURE_DISPLAY_ENTITY_BODY, _T("The MS-Logoff digest header has been returned from the Web site. This header specifically instructs the digest package to purge credentials for the associated realm. This error will only be returned if INTERNET_ERROR_MASK_LOGIN_FAILURE_DISPLAY_ENTITY_BODY has been set."), 
	ERROR_INTERNET_NEED_MSN_SSPI_PKG, _T("Not currently implemented."), 
	ERROR_INTERNET_NOT_INITIALIZED, _T("Initialization of the Win32 Internet API has not occurred. Indicates that a higher-level function, such as InternetOpen, has not been called yet."), 
	ERROR_INTERNET_SEC_CERT_ERRORS, _T("The SSL certificate contains errors."), 
	ERROR_INTERNET_SEC_CERT_NO_REV, _T("ERROR_INTERNET_SEC_CERT_REV_FAILED"),
*/

//////////////////////////////////////////////////////////////////////
// Construction/Destruction
//////////////////////////////////////////////////////////////////////

CInetSessAsy::CInetSessAsy(DWORD dwFlags) :
	CInternetSession(NULL,
	1,
	(DWORD)PRE_CONFIG_INTERNET_ACCESS,
	(LPCTSTR)NULL,
	(LPCTSTR)NULL,
	(DWORD)dwFlags)
{
	InitProps();
	if (dwFlags & INTERNET_FLAG_ASYNC)
	{
		try
		{
			VERIFY(EnableStatusCallback());
			m_bAsynchronous = TRUE;
		}
		catch (CInternetException* pEx)
		{
		   pEx->ReportError();
		   pEx->Delete(); 
		}
	}
}

void CInetSessAsy::InitProps()
{
	m_nPort = INTERNET_INVALID_PORT_NUMBER;
	m_dwStatusCode = HTTP_STATUS_DENIED;
	m_nStep = 0;
	m_bIsError = FALSE;
	m_bContinue = TRUE;
	m_pHttpFile = NULL;
	m_pConnection = NULL;
	m_bCompleted = FALSE;
	m_bAsynchronous = FALSE;
}

CInetSessAsy::~CInetSessAsy()
{
	CloseAll();
}

void CInetSessAsy::CloseAll()
{
	if (m_pHttpFile != NULL)
	{
		m_pHttpFile->Close(); 
		delete m_pHttpFile;
		m_pHttpFile = NULL;
	}

	if (m_pConnection != NULL)
	{
		m_pConnection->Close();
		delete m_pConnection;
		m_pConnection = NULL;
	}
	
	m_nStep = 0;
	m_bIsError = FALSE;
	m_bContinue = TRUE;
}

BOOL CInetSessAsy::ErrorOut(HWND hErr, DWORD dError, _TCHAR *szCallFunc)
{
	_TCHAR szTemp[356] = "";
	_TCHAR* szBuffer = NULL;
	_TCHAR* szBufferFinal = NULL;
    DWORD dwIntError = 0;
	DWORD dwLength = 0;
    char strName[256]="";

    FormatMessage(FORMAT_MESSAGE_FROM_HMODULE,
        GetModuleHandle("wininet.dll"), dError, 0,
		(LPSTR)strName, 256, NULL);
	wsprintf (szTemp, "%s error code: %d\nMessage: %s\n", 
		szCallFunc, dError, strName);
    
	int response = 0;
        
    if (dError == ERROR_INTERNET_EXTENDED_ERROR)
    {
		InternetGetLastResponseInfo (&dwIntError, NULL, &dwLength);
		if (dwLength)
		{
			if (!(szBuffer = (TCHAR *) LocalAlloc(LPTR, dwLength)))
            {
				lstrcat(szTemp, TEXT("Unable to allocate memory to display Internet error code. Error code: "));
                lstrcat(szTemp, TEXT(_itoa (GetLastError(), szBuffer, 10)));
                lstrcat(szTemp, TEXT("\n"));
//              response = MessageBox(hErr, (LPCTSTR)szTemp, _T("Error"), MB_OK);
				TRACE(_T("*** ErrorOut: %s"), szTemp);
                return FALSE;
            }
            if (!InternetGetLastResponseInfo (&dwIntError, (LPTSTR) szBuffer, 
                &dwLength))
            {
                lstrcat (szTemp, TEXT ( "Unable to get Internet error. Error code: ") );
                lstrcat (szTemp, TEXT (_itoa (GetLastError(), szBuffer, 10)  ) );
                lstrcat (szTemp, TEXT ("\n") );
//              response = MessageBox(hErr, (LPCTSTR)szTemp, _T("Error"), MB_OK);
				TRACE(_T("*** ErrorOut: %s"), szTemp);
                return FALSE;
            }
            if ( !(szBufferFinal = (TCHAR *) LocalAlloc ( LPTR,  
                   (strlen (szBuffer) +strlen (szTemp) + 1)  ) )  )
            {
                lstrcat (szTemp, TEXT ( "Unable to allocate memory. Error code: ") );
                lstrcat (szTemp, TEXT (_itoa (GetLastError(), szBuffer, 10)  ) );
                lstrcat (szTemp, TEXT ("\n") );
//               response = MessageBox(hErr, (LPCTSTR)szTemp, _T("Error"), MB_OK);
				TRACE(_T("*** ErrorOut: %s"), szTemp);
                return FALSE;
            }
            lstrcpy (szBufferFinal, szTemp);
            lstrcat (szBufferFinal, szBuffer);
            LocalFree (szBuffer);
//          response = MessageBox(hErr, (LPCTSTR)szBufferFinal, _T("Error"), MB_OK);
			TRACE(_T("*** ErrorOut: %s"), szBufferFinal);
            LocalFree (szBufferFinal);
		}
    }
    else
    {
//		response = MessageBox(hErr, (LPCTSTR)szTemp, _T("Error") ,MB_OK);
		TRACE(_T("*** ErrorOut: %s"), szTemp);
    }

	return response;
}

void CInetSessAsy::OnStatusCallback(DWORD dwContext, DWORD dwInternetStatus, LPVOID lpvStatusInformation, DWORD dwStatusInformationLength)
{
	// Check dwInternetStatus and show
	m_bContinue = FALSE;
	BOOL bFound = FALSE; 
	for (int nItem = 0; nItem < sizeof(m_inetStatus)/sizeof(INETSTATUS); nItem++)
	{
		if (m_inetStatus[nItem].dwInternetStatus == dwInternetStatus)
		{
#if DEBUG
			afxDump << _T("*** OnStatusCallback(state): ") << m_inetStatus[nItem].lpzsDes << "\n";
#endif
			bFound = TRUE; 
		}
	}
	if (!bFound)
	{
		TRACE(_T("*** OnStatusCallback(state): State not found\n"));
	}

	// Get HINTERNET
	if (dwInternetStatus == INTERNET_STATUS_HANDLE_CREATED ||
		dwInternetStatus == INTERNET_STATUS_REQUEST_COMPLETE)
	{
		bFound = FALSE; 
		DWORD dwError = ((LPINTERNET_ASYNC_RESULT)lpvStatusInformation)->dwError;
		if (dwError == ERROR_INTERNET_EXTENDED_ERROR)
		{
			ErrorOut(NULL, dwError, _T("CInetSessAsy::OnStatusCallback"));
			bFound = TRUE;
			m_bIsError = TRUE;
		}
		else
		{
			for (int nErr = 0; nErr < sizeof(m_inetErrors)/sizeof(INETSTATUS); nErr++)
			{
				if (m_inetErrors[nErr].dwInternetStatus == dwError)
				{
//					MessageBox(NULL, m_inetErrors[nErr].lpzsDes, _T("OnStatusCallback(error):"), MB_OK);
#if DEBUG
					afxDump << _T("*** OnStatusCallback(error): ") << m_inetErrors[nErr].lpzsDes << "\n";
#endif
					bFound = TRUE; 
					m_bIsError = TRUE;
				}
			}
		}

		if (!bFound)
		{
			HINTERNET hInternet = (HINTERNET)((LPINTERNET_ASYNC_RESULT)lpvStatusInformation)->dwResult;
			if (hInternet != INVALID_HANDLE_VALUE)
			{
				TRACE(_T("*** OnStatusCallback(handler): Is InetHandler\n"));
				m_bContinue = TRUE;
			}
			else
			{
//				MessageBox(NULL, _T("InetHandler = INVALID_HANDLE_VALUE"), _T("OnStatusCallback(handler)"), MB_OK);
				TRACE(_T("*** OnStatusCallback(handler): InetHandler = INVALID_HANDLE_VALUE\n"));
				m_bIsError = TRUE;
			}
		}
	}
	else
	{
		// Show lpvStatusInformation
		LPSTR pStr = (LPSTR)(lpvStatusInformation);
		if (pStr != NULL)
		{
//			MessageBox(NULL, pStr, _T("StatusInformation"), MB_OK);
			TRACE(_T("*** OnStatusCallback(info): %s\n"), pStr);
		}
	}
	if (dwInternetStatus == INTERNET_STATUS_HANDLE_CLOSING)
	{
		m_bContinue = TRUE;
		m_bCompleted = TRUE;
	}
}

BOOL CInetSessAsy::SetServerObject(LPCTSTR lpszURL)
{
	CString strURL(lpszURL);
	int nPos = strURL.Find(_T("://"));
	if (nPos == -1)
	{
		strURL = CString(_T("http://"))+strURL;
	}

	DWORD dwServiceType;
	m_nPort = INTERNET_INVALID_PORT_NUMBER;
	if (!AfxParseURL(strURL, dwServiceType, m_strServer, m_strObject, m_nPort) ||
		dwServiceType != INTERNET_SERVICE_HTTP)
	{
		return FALSE;
	}
	return TRUE;
}

/*

BOOL CInetSessAsy::InitSession()
{
	if (m_bIsSession)
		return TRUE;
	
	m_bIsSession = TRUE;
	return TRUE; 

	BOOL bRetVal = FALSE;
	try
	{
		DWORD dwContext = GetContext(); 
		m_pFile = (CInternetFile*)OpenURL(m_strServer, dwContext);
		bRetVal = (m_pFile != NULL);
	}
	catch (CInternetException* pEx)
	{
		if (pEx->m_dwError != ERROR_IO_PENDING)
		{
			pEx->ReportError();
		}
		else
			bRetVal = TRUE;
		pEx->Delete(); 
	}
	catch (CNotSupportedException* pEx)
	{
		pEx->ReportError(); 
		pEx->Delete(); 
	}
	m_bIsSession = bRetVal;
	return bRetVal;
}
*/

BOOL CInetSessAsy::OpenHttpFile()
{
	BOOL bRetVal = FALSE;
	try
	{
		DWORD dwHttpRequestFlags = 
			INTERNET_FLAG_EXISTING_CONNECT|INTERNET_FLAG_NO_AUTO_REDIRECT;
		m_pConnection = GetHttpConnection(m_strServer);
		DWORD dwContext = m_pConnection->GetContext(); 
		m_pHttpFile = m_pConnection->OpenRequest(CHttpConnection::HTTP_VERB_GET,
			m_strObject, NULL, dwContext, NULL, NULL, dwHttpRequestFlags);
		VERIFY(m_pHttpFile != NULL);
		m_pHttpFile->SendRequest();
		bRetVal = TRUE;
	}
	catch (CInternetException* pEx)
	{
		if (pEx->m_dwError != ERROR_IO_PENDING)
		{
			pEx->ReportError();
		}
		else
			bRetVal = TRUE;
		pEx->Delete(); 
	}
	catch (CNotSupportedException* pEx)
	{
		pEx->ReportError(); 
		pEx->Delete(); 
	}
	return bRetVal;
}


BOOL CInetSessAsy::GetStatusCode()
{
	VERIFY(m_pHttpFile != NULL);
	BOOL bRetVal = FALSE;
	try
	{
		m_pHttpFile->QueryInfoStatusCode(m_dwStatusCode);
		bRetVal = TRUE;
	}
	catch (CInternetException* pEx)
	{
		if (pEx->m_dwError != ERROR_IO_PENDING)
		{
			pEx->ReportError();
		}
		else
			bRetVal = TRUE;
		pEx->Delete(); 
	}
	catch (CNotSupportedException* pEx)
	{
		pEx->ReportError(); 
		pEx->Delete(); 
	}
	return bRetVal;
}

DWORD CInetSessAsy::TryURL(LPCTSTR lpszURL, int nSecTimeOut, LPVOID pParam)
{
	if (m_nStep != 0)
		return FALSE;
	
	m_bIsError = FALSE;
	m_dwStatusCode = HTTP_STATUS_DENIED;
	
	if (!SetServerObject(lpszURL))
		return FALSE;
	
	m_bTimeOut = FALSE;
	
	if (m_bAsynchronous)
	{
		//Check enable Stoped by User
		BOOL bSheckStop = FALSE;
		ThreadInfo* pThreadInfo = (ThreadInfo*)pParam;
		if (pThreadInfo != NULL)
			bSheckStop = (pThreadInfo->m_hEventProgressStop != NULL);

		m_bContinue = TRUE;
		m_bCompleted = FALSE;
		m_bIsError = FALSE;

		LONG nTimeOut = (LONG)nSecTimeOut;
		time_t ltime;
		time_t ctime;
		time(&ltime);
		
		while (!m_bCompleted && !m_bIsError)
		{
			// Check Stoped by User
			if (bSheckStop)
			{
				if (WaitForSingleObject(pThreadInfo->m_hEventProgressStop, 0)
						== WAIT_OBJECT_0)
				{
					// Stoped by User
					pThreadInfo->nExitCode = STOPEDBYUSER;
					m_bContinue = FALSE;
					// Close connection
					CloseAll();
					// ... and wait completed
					m_nStep = 3;
					Sleep(0);
				}
			}
			
			if (m_bContinue)
			{
				m_bContinue = FALSE;
				switch (m_nStep)
				{
					case 0:
						// GetHttpConnection and SendRequest;
						m_bIsError = !OpenHttpFile();
						if (!m_bIsError)
							m_nStep = 1;
						// wait to GetStatusCode
						break;
					case 1:
						// Call QueryInfoStatusCode
						m_bIsError = !GetStatusCode();
						if (!m_bIsError)
						{
							m_nStep = 2;
							m_bCompleted = TRUE;
						}
						break;
					case 2:
						break;
					case 3:
						m_bCompleted = TRUE;
				}
			}
			Sleep(0);
			
			  // Check TimeOut
			if (nSecTimeOut > 0)
			{
				time(&ctime);
				if (ctime-ltime > nTimeOut)
				{
					m_bTimeOut = TRUE;
					m_bContinue = FALSE;
					CloseAll();
					m_nStep = 3;
					Sleep(0);
				}
			}
		}
	}
	else
	{
		try
		{
			DWORD dwHttpRequestFlags = 
				INTERNET_FLAG_EXISTING_CONNECT|INTERNET_FLAG_NO_AUTO_REDIRECT;
			m_pConnection = GetHttpConnection(m_strServer);
			DWORD dwContext = m_pConnection->GetContext(); 
			m_pHttpFile = m_pConnection->OpenRequest(CHttpConnection::HTTP_VERB_GET,
				m_strObject, NULL, dwContext, NULL, NULL, dwHttpRequestFlags);
			VERIFY(m_pHttpFile != NULL);
			m_pHttpFile->SendRequest();
			m_pHttpFile->QueryInfoStatusCode(m_dwStatusCode);
		}
		catch (CInternetException* pEx)
		{
			pEx->ReportError();
			pEx->Delete(); 
		}
		catch (CNotSupportedException* pEx)
		{
			pEx->ReportError(); 
			pEx->Delete(); 
		}
	}
	
	CloseAll();
	return m_dwStatusCode;
}

