// MainFrm.cpp : implementation of the CMainFrame class
//

#include "stdafx.h"
#include "URLChecker.h"

#include "URLCheck.h"
#include "UrlObj.h"
#include "URLCheckerDoc.h"

#include "PropSheet.h"
#include "MainFrm.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CMainFrame

IMPLEMENT_DYNCREATE(CMainFrame, CFrameWnd)

BEGIN_MESSAGE_MAP(CMainFrame, CFrameWnd)
	//{{AFX_MSG_MAP(CMainFrame)
	ON_WM_CREATE()
	ON_COMMAND(ID_OPTIONS_PROPERTIES, OnOptionsProperties)
	ON_UPDATE_COMMAND_UI(ID_OPTIONS_PROPERTIES, OnUpdateOptionsProperties)
	//}}AFX_MSG_MAP
	ON_MESSAGE(WM_USER_PROGRESS_START, OnProgressStart)
	ON_MESSAGE(WM_USER_PROGRESS_END, OnProgressEnd)	
	ON_MESSAGE(WM_USER_PROGRESS_SHOW, OnProgressShow)
	ON_MESSAGE(WM_USER_UPDATE_STATE, OnProgressUpdate)
END_MESSAGE_MAP()

static UINT indicators[] =
{
	ID_SEPARATOR,           // status line indicator
	ID_INDICATOR_CAPS,
	ID_INDICATOR_NUM,
	ID_INDICATOR_SCRL,
};

/////////////////////////////////////////////////////////////////////////////
// CMainFrame construction/destruction

CMainFrame::CMainFrame()
{
	// TODO: add member initialization code here
	
}

CMainFrame::~CMainFrame()
{
}

int CMainFrame::OnCreate(LPCREATESTRUCT lpCreateStruct)
{
	if (CFrameWnd::OnCreate(lpCreateStruct) == -1)
		return -1;
	
	if (!m_wndToolBar.CreateEx(this, TBSTYLE_FLAT, WS_CHILD | WS_VISIBLE | CBRS_TOP
		| CBRS_GRIPPER | CBRS_TOOLTIPS | CBRS_FLYBY | CBRS_SIZE_DYNAMIC) ||
		!m_wndToolBar.LoadToolBar(IDR_MAINFRAME))
	{
		TRACE0("Failed to create toolbar\n");
		return -1;      // fail to create
	}

	if (!m_wndStatusBar.Create(this) ||
		!m_wndStatusBar.SetIndicators(indicators,
		  sizeof(indicators)/sizeof(UINT)))
	{
		TRACE0("Failed to create status bar\n");
		return -1;      // fail to create
	}

	// TODO: Delete these three lines if you don't want the toolbar to
	//  be dockable
	m_wndToolBar.EnableDocking(CBRS_ALIGN_ANY);
	EnableDocking(CBRS_ALIGN_ANY);
	DockControlBar(&m_wndToolBar);

	return 0;
}

BOOL CMainFrame::PreCreateWindow(CREATESTRUCT& cs)
{
	if( !CFrameWnd::PreCreateWindow(cs) )
		return FALSE;
	// TODO: Modify the Window class or styles here by modifying
	//  the CREATESTRUCT cs

	return TRUE;
}

/////////////////////////////////////////////////////////////////////////////
// CMainFrame diagnostics

#ifdef _DEBUG
void CMainFrame::AssertValid() const
{
	CFrameWnd::AssertValid();
}

void CMainFrame::Dump(CDumpContext& dc) const
{
	CFrameWnd::Dump(dc);
}

#endif //_DEBUG

/////////////////////////////////////////////////////////////////////////////
// CMainFrame message handlers

void CMainFrame::StartProgress(int nUpper, int nStep)
{
	if (m_wndDlgBar.GetSafeHwnd() == NULL)
		VERIFY(m_wndDlgBar.Create(this, IDD_DIALOGBAR,
			CBRS_BOTTOM, IDD_DIALOGBAR));
	m_wndDlgBar.SetBarStyle(CBRS_ALIGN_BOTTOM | CBRS_ALIGN_LEFT);

	CProgressCtrl* pProgress = 
		(CProgressCtrl*)m_wndDlgBar.GetDlgItem(IDC_PROGRESS);
	
	pProgress->SetRange32(0, nUpper);
	pProgress->SetPos(0);
	pProgress->SetStep(nStep);
	
	ShowControlBar(&m_wndStatusBar, FALSE, FALSE);
	ShowControlBar(&m_wndDlgBar, TRUE, FALSE);
	EnableDocking(CBRS_ALIGN_BOTTOM);
}

void CMainFrame::EndProgress()
{
	if (m_wndDlgBar.GetSafeHwnd() != NULL)
	{
		ShowControlBar(&m_wndDlgBar, FALSE, FALSE);
		ShowControlBar(&m_wndStatusBar, TRUE, FALSE);
		EnableDocking(CBRS_ALIGN_ANY);

		m_wndDlgBar.DestroyWindow();
	}
	
	// m_pWinTread to NULL
	CURLCheckerApp* pApp = (CURLCheckerApp*)AfxGetApp();
	VERIFY(pApp != NULL);
	pApp->m_pWinTread = NULL;
}

void CMainFrame::StepProgress()
{
	CProgressCtrl* pProgress = 
		(CProgressCtrl*)m_wndDlgBar.GetDlgItem(IDC_PROGRESS);
	if (pProgress != NULL)
	{
		// Set next step
		pProgress->StepIt();
		m_wndDlgBar.UpdateWindow();
	}
}

LRESULT CMainFrame::OnProgressStart(WPARAM wParam, LPARAM lParam)
{
	StartProgress((int)wParam, (int)lParam);
	return 0;
}

LRESULT CMainFrame::OnProgressEnd(WPARAM wParam, LPARAM lParam)
{
	EndProgress();
	return 0;
}

LRESULT CMainFrame::OnProgressShow(WPARAM wParam, LPARAM lParam)
{
	StepProgress();
	return 0;
}

LRESULT CMainFrame::OnProgressUpdate(WPARAM wParam, LPARAM lParam)
{
	CURLCheckerDoc* pDoc = (CURLCheckerDoc*)GetActiveDocument();
	VERIFY(pDoc != NULL);
	pDoc->UpdateState((int)wParam, (int)lParam);
	return 0;
}

void CMainFrame::OnOptionsProperties() 
{
	CPropSheet propSheet;
	propSheet.DoModal();
}

void CMainFrame::OnUpdateOptionsProperties(CCmdUI* pCmdUI) 
{
	CURLCheckerApp* pApp = (CURLCheckerApp*)AfxGetApp();
	VERIFY(pApp != NULL);
	pCmdUI->Enable(pApp->m_pWinTread == NULL); 
}
