// URLChecker.cpp : Defines the class behaviors for the application.
//

#include "stdafx.h"
#include "URLChecker.h"

#include "InetSessAsy.h"

#include "PropSheet.h"

#include "MainFrm.h"
#include "URLCheck.h"

#include "UrlObj.h"
#include "URLCheckerDoc.h"
#include "URLCheckerView.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CURLCheckerApp

BEGIN_MESSAGE_MAP(CURLCheckerApp, CWinApp)
	//{{AFX_MSG_MAP(CURLCheckerApp)
	ON_COMMAND(ID_APP_ABOUT, OnAppAbout)
	ON_COMMAND(ID_OPTIONS_STOP, OnOptionsStop)
	ON_UPDATE_COMMAND_UI(ID_OPTIONS_STOP, OnUpdateOptionsStop)
	ON_COMMAND(ID_OPTIONS_START, OnOptionsStart)
	ON_UPDATE_COMMAND_UI(ID_OPTIONS_START, OnUpdateOptionsStart)
	ON_COMMAND(ID_OPTIONS_CONTINUE, OnOptionsContinue)
	ON_UPDATE_COMMAND_UI(ID_OPTIONS_CONTINUE, OnUpdateOptionsContinue)
	//}}AFX_MSG_MAP
	// Standard file based document commands
	ON_COMMAND(ID_FILE_NEW, CWinApp::OnFileNew)
	ON_COMMAND(ID_FILE_OPEN, CWinApp::OnFileOpen)
	// Standard print setup command
	ON_COMMAND(ID_FILE_PRINT_SETUP, CWinApp::OnFilePrintSetup)
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CURLCheckerApp construction

CURLCheckerApp::CURLCheckerApp()
{
	m_ThreadInfo.m_hEventProgressStop = NULL;
	m_ThreadInfo.m_hEventProgressStoped = NULL;
	m_bAutoSizeColumns = TRUE;
	m_bAutoScroll = TRUE;
	m_bIsChange = FALSE;
}

/////////////////////////////////////////////////////////////////////////////
// The one and only CURLCheckerApp object

CURLCheckerApp theApp;

/////////////////////////////////////////////////////////////////////////////
// CURLCheckerApp initialization

BOOL CURLCheckerApp::InitInstance()
{

	AfxEnableControlContainer();

	// Standard initialization
	// If you are not using these features and wish to reduce the size
	//  of your final executable, you should remove from the following
	//  the specific initialization routines you do not need.

#ifdef _AFXDLL
	Enable3dControls();			// Call this when using MFC in a shared DLL
#else
	Enable3dControlsStatic();	// Call this when linking to MFC statically
#endif

	// Change the registry key under which our settings are stored.
	// TODO: You should modify this string to be something appropriate
	// such as the name of your company or organization.
	SetRegistryKey(_T("Local AppWizard-Generated Applications"));

	LoadStdProfileSettings();  // Load standard INI file options (including MRU)

	// Register the application's document templates.  Document templates
	//  serve as the connection between documents, frame windows and views.

	CSingleDocTemplate* pDocTemplate;
	pDocTemplate = new CSingleDocTemplate(
		IDR_MAINFRAME,
		RUNTIME_CLASS(CURLCheckerDoc),
		RUNTIME_CLASS(CMainFrame),       // main SDI frame window
		RUNTIME_CLASS(CURLCheckerView));
	AddDocTemplate(pDocTemplate);

	// Parse command line for standard shell commands, DDE, file open
	CCommandLineInfo cmdInfo;
	ParseCommandLine(cmdInfo);

	// Dispatch commands specified on the command line
	if (!ProcessShellCommand(cmdInfo))
		return FALSE;

	// Get settings
	m_bAutoScroll = GetProfileInt(_T("Settings"), _T("AutoScroll"), 1); 
	m_bAutoSizeColumns = GetProfileInt(_T("Settings"), _T("AutoSize"), 1); 
	m_bAsynchronous = GetProfileInt(_T("Settings"), _T("Asynchronous"), 1);
	m_nTimeOut = GetProfileInt(_T("Settings"), _T("TimeOut"), 30); 
	
	// The one and only window has been initialized, so show and update it.
	m_pMainWnd->ShowWindow(SW_SHOW);
	m_pMainWnd->UpdateWindow();
	
	return TRUE;
}


/////////////////////////////////////////////////////////////////////////////
// CAboutDlg dialog used for App About

class CAboutDlg : public CDialog
{
public:
	CAboutDlg();

// Dialog Data
	//{{AFX_DATA(CAboutDlg)
	enum { IDD = IDD_ABOUTBOX };
	//}}AFX_DATA

	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CAboutDlg)
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support
	//}}AFX_VIRTUAL

// Implementation
protected:
	//{{AFX_MSG(CAboutDlg)
	virtual BOOL OnInitDialog();
	afx_msg void OnDestroy();
	afx_msg void OnUrl();
	afx_msg void OnEmail();
	afx_msg HBRUSH OnCtlColor(CDC* pDC, CWnd* pWnd, UINT nCtlColor);
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()

	CFont m_fontURL;
	CFont m_fontMAIL;
	HCURSOR m_hcursor;
	COLORREF m_clrUrlText;
	COLORREF m_clrUrlBkgnd;
	HWND m_hWndUrl;
	HWND m_hWndMail;
};

CAboutDlg::CAboutDlg() : 
	CDialog(CAboutDlg::IDD),
	m_hWndUrl(NULL),
	m_hWndMail(NULL),
	m_hcursor(NULL)
{
	//{{AFX_DATA_INIT(CAboutDlg)
	//}}AFX_DATA_INIT
}

void CAboutDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CAboutDlg)
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CAboutDlg, CDialog)
	//{{AFX_MSG_MAP(CAboutDlg)
	ON_WM_DESTROY()
	ON_BN_CLICKED(IDC_URL, OnUrl)
	ON_BN_CLICKED(IDC_EMAIL, OnEmail)
	ON_WM_CTLCOLOR()
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

// App command to run the dialog
void CURLCheckerApp::OnAppAbout()
{
	CAboutDlg aboutDlg;
	aboutDlg.DoModal();
}

/////////////////////////////////////////////////////////////////////////////
// CURLCheckerApp message handlers


int CURLCheckerApp::ExitInstance() 
{
	StopProgress();

	if (m_ThreadInfo.m_hEventProgressStop != NULL)
	{
		CloseHandle(m_ThreadInfo.m_hEventProgressStop);
		m_ThreadInfo.m_hEventProgressStop = NULL;
	}	
	if (m_ThreadInfo.m_hEventProgressStoped != NULL)
	{
		CloseHandle(m_ThreadInfo.m_hEventProgressStoped);
		m_ThreadInfo.m_hEventProgressStoped = NULL;
	}

	if (m_bIsChange)
	{
		// Save settings
		WriteProfileInt(_T("Settings"), _T("AutoScroll"), (int)m_bAutoScroll); 
		WriteProfileInt(_T("Settings"), _T("AutoSize"), (int)m_bAutoSizeColumns); 
		WriteProfileInt(_T("Settings"), _T("Asynchronous"), (int)m_bAsynchronous);
		WriteProfileInt(_T("Settings"), _T("TimeOut"), m_nTimeOut); 
	}
	
	return CWinApp::ExitInstance();
}

//////////////////////////////////////////
// Killer working thread
//
void CURLCheckerApp::StopProgress()
{
	DWORD dwExitCode;
	if (m_pWinTread != NULL &&
			GetExitCodeThread(m_pWinTread->m_hThread, &dwExitCode) &&
			dwExitCode == STILL_ACTIVE)
	{
		////////////////////////////////////////////////////////////////////
		//         "ProgressStop":
		//      "ProgressStop"
		//    . ,   ,
		//      "ProgressStop",   .
		//       ProgressStop
		//    ProgressStoped,
		//        
		//       (m_pWinTread)
		/////////////////////////////////////////////////////////////////////
		// The Erasure of a working thread is made with the help of setting an event "ProgressStop":
		// The Working thread periodically checks an event "ProgressStop"
		// in execution time calculation. Therefore, to destroy a thread,
		// Which could expect an event "ProgressStop", we establish this event.
		// On an exit from a thread by an event ProgressStop
		// the additional event ProgressStoped is installed,
		// With the help of which we wait for complete closing the thread
		// for a consequent erasure of the reference on it (m_pWinTread)
		/////////////////////////////////////////////////////////////////////
		
		SetEvent(m_ThreadInfo.m_hEventProgressStop);
		WaitForSingleObject(m_ThreadInfo.m_hEventProgressStoped, INFINITE);
		m_pWinTread = NULL;
	}
}

void CURLCheckerApp::CheckUrls(int nItemUpdate) 
{
	if (m_ThreadInfo.m_hEventProgressStop != NULL)
	{
		CloseHandle(m_ThreadInfo.m_hEventProgressStop);
		m_ThreadInfo.m_hEventProgressStop = NULL;
	}	
	if (m_ThreadInfo.m_hEventProgressStoped != NULL)
	{
		CloseHandle(m_ThreadInfo.m_hEventProgressStoped);
		m_ThreadInfo.m_hEventProgressStoped = NULL;
	}	
	m_ThreadInfo.m_hEventProgressStop   = CreateEvent(NULL, FALSE, FALSE, NULL);	// auto reset, initially reset
	m_ThreadInfo.m_hEventProgressStoped = CreateEvent(NULL, FALSE, FALSE, NULL);	// auto reset, initially reset
	ResetEvent(m_ThreadInfo.m_hEventProgressStop);
	ResetEvent(m_ThreadInfo.m_hEventProgressStoped);
	
	CFrameWnd* pWnd = (CFrameWnd*)AfxGetMainWnd();
	VERIFY(pWnd != NULL);
	CURLCheckerDoc* pDoc = (CURLCheckerDoc*)pWnd->GetActiveDocument(); 
	VERIFY(pDoc != NULL);
	m_ThreadInfo.pDoc = (LPVOID)pDoc;
	m_ThreadInfo.hwndNotify = AfxGetMainWnd()->m_hWnd;
	m_ThreadInfo.nSuspendIndex = pDoc->m_nSuspendIndex; 
	m_ThreadInfo.nExitCode = PRESTARTSTATE;
	if (nItemUpdate != (-1) && m_ThreadInfo.hwndNotify != NULL)
		::PostMessage(m_ThreadInfo.hwndNotify,
			WM_USER_UPDATE_STATE, (WPARAM)nItemUpdate, (LPARAM)2);
	
	m_pWinTread = AfxBeginThread((AFX_THREADPROC)CheckThreadProc,
		(LPVOID)&m_ThreadInfo);
}

void CURLCheckerApp::OnOptionsStop() 
{
	StopProgress();
}

void CURLCheckerApp::OnUpdateOptionsStop(CCmdUI* pCmdUI) 
{
	pCmdUI->Enable(m_pWinTread != NULL); 
}

void CURLCheckerApp::OnOptionsStart() 
{
	CFrameWnd* pWnd = (CFrameWnd*)AfxGetMainWnd();
	VERIFY(pWnd != NULL);
	CURLCheckerDoc* pDoc = (CURLCheckerDoc*)pWnd->GetActiveDocument(); 
	VERIFY(pDoc != NULL);
	
	// Clear aborted item
	int nItemUpdate = pDoc->m_nSuspendIndex;
	if (nItemUpdate != (-1))
		pDoc->ClearAborted();
	
	// Check Urls
	CheckUrls(nItemUpdate);
}

void CURLCheckerApp::OnUpdateOptionsStart(CCmdUI* pCmdUI) 
{
	CFrameWnd* pWnd = (CFrameWnd*)AfxGetMainWnd();
	VERIFY(pWnd != NULL);
	CURLCheckerDoc* pDoc = (CURLCheckerDoc*)pWnd->GetActiveDocument(); 
	VERIFY(pDoc != NULL);
	pCmdUI->Enable(m_pWinTread == NULL && pDoc->m_arrUrls.GetSize()); 
}

void CURLCheckerApp::OnOptionsContinue() 
{
	CheckUrls();
}

void CURLCheckerApp::OnUpdateOptionsContinue(CCmdUI* pCmdUI) 
{
	CFrameWnd* pWnd = (CFrameWnd*)AfxGetMainWnd();
	VERIFY(pWnd != NULL);
	CURLCheckerDoc* pDoc = (CURLCheckerDoc*)pWnd->GetActiveDocument(); 
	VERIFY(pDoc != NULL);
	pCmdUI->Enable(m_pWinTread == NULL && pDoc->m_nSuspendIndex != (-1)); 
}

////////////////////////////////////////////////
// Working thread proc for process check URLs
//
UINT CheckThreadProc(LPVOID pParam)
{
	// Get and check ThreadInfo
	ThreadInfo* pThreadInfo = (ThreadInfo*)pParam;
    if (pThreadInfo == NULL)
		return NOTVALIDINFO;   // <- pThreadInfo is not valid

	AFX_MANAGE_STATE(AfxGetAppModuleState());
	pThreadInfo->nExitCode = SUCCESSFUL; // <- Successful start

	CURLCheckerDoc* pDoc = (CURLCheckerDoc*)pThreadInfo->pDoc; 
	VERIFY(pDoc != NULL);
	int nSize = pDoc->m_arrUrls.GetSize();
	BOOL pNotify = (pThreadInfo->hwndNotify != NULL);
	DWORD dwState = 0;
	
	// Application props
	CURLCheckerApp* pApp = (CURLCheckerApp*)AfxGetApp();
	VERIFY(pApp != NULL);
	int nTimeOut = pApp->m_nTimeOut; 

	CUrlObj* pObj = NULL;
	BOOL bIsCancel = FALSE;
	int nIndexFrom = 0;
	if (pDoc->m_nSuspendIndex != (-1))
	{
		nIndexFrom = pDoc->m_nSuspendIndex;
		pDoc->ClearAborted();
		if (pNotify)
			::PostMessage(pThreadInfo->hwndNotify,
				WM_USER_UPDATE_STATE, (WPARAM)nIndexFrom, (LPARAM)2);
	}
	
	// Start progress: (set range)
	if (pNotify)
		::PostMessage(pThreadInfo->hwndNotify,
			WM_USER_PROGRESS_START, (WPARAM)pDoc->m_arrUrls.GetSize()-nIndexFrom, (LPARAM)1);
	
	CInetSessAsy inetSess(((pApp->m_bAsynchronous)?INTERNET_FLAG_ASYNC:0));

	for (int nItem = nIndexFrom; nItem < nSize; nItem++)
	{
		// Get next object
		pObj = (CUrlObj*)pDoc->m_arrUrls.GetAt(nItem);
		if (pObj != NULL)
		{
			// Begin check
			if (pNotify)
				::PostMessage(pThreadInfo->hwndNotify,
					WM_USER_UPDATE_STATE, (WPARAM)nItem, (LPARAM)0);

			// Check EventProgressStop
			if (pThreadInfo->m_hEventProgressStop != NULL)
			{
				if (WaitForSingleObject(pThreadInfo->m_hEventProgressStop, 0)
						== WAIT_OBJECT_0)
				{
					// Stoped by User
					pThreadInfo->nExitCode = STOPEDBYUSER;
					bIsCancel = TRUE;
					pDoc->SetAborted(nItem, pObj);
				}
			}

			// Pocess checking
			if (!bIsCancel)
			{
				// Reset object State
				if (CUrlObj::TIME_OUT == pObj->m_nState)
					pObj->m_nState = CUrlObj::UNDEFINED;

				// Check object
				dwState = inetSess.TryURL(pObj->m_strURL, nTimeOut, (LPVOID)pThreadInfo);
				
				// Now check EventProgressStop (canceled) in TryURL :-(
				if (pThreadInfo->m_hEventProgressStop != NULL)
					bIsCancel = (pThreadInfo->nExitCode == STOPEDBYUSER);
				
				if (!bIsCancel)
				{
					// Result check object
					if (inetSess.m_bTimeOut)
					{
						if (CUrlObj::TIME_OUT != pObj->m_nState)
						{
							pObj->m_nState = CUrlObj::TIME_OUT;
							pDoc->SetModifiedFlag(); 
						}
					}
					if (dwState != pObj->m_dwStatusCode)
					{
						pObj->m_dwStatusCode = dwState;
						pDoc->SetModifiedFlag(); 
					}
					Sleep(SLEEPMS);
				}
				else
				{
					// Stoped by User
					pDoc->SetAborted(nItem, pObj);
				}
			}
			
			// Refresh state object
			if (pNotify)
				::PostMessage(pThreadInfo->hwndNotify,
					WM_USER_UPDATE_STATE, (WPARAM)nItem, (LPARAM)1);
		}
		
		// New step progress
		if (pNotify)
			::PostMessage(pThreadInfo->hwndNotify, WM_USER_PROGRESS_SHOW, 0, 0);
		
		// Check cancel
		if (bIsCancel) break;
	}
	
	// End progress
	if (pNotify)
		::PostMessage(pThreadInfo->hwndNotify,
			WM_USER_PROGRESS_END, 0, 0);
	
	// For remove this thread-ref (m_pWinTread) on exit (see StopSearcher())
	if (pThreadInfo->nExitCode == STOPEDBYUSER)
		SetEvent(pThreadInfo->m_hEventProgressStoped);
	
	// Write resalt to file
	
	// End thread
	AfxEndThread(pThreadInfo->nExitCode, TRUE);
	return 0;
}

BOOL CAboutDlg::OnInitDialog() 
{
	CDialog::OnInitDialog();
	CWinApp* pApp = AfxGetApp();
	VERIFY(pApp != NULL);
   	
	// Colors
	m_clrUrlText = RGB(0,0,255);;
	m_clrUrlBkgnd = ::GetSysColor(COLOR_3DFACE); //COLOR_BTNFACE

	// Cursor
	m_hcursor = pApp->LoadCursor(IDC_CURSORURL);

	// URL font
	CWnd* pWnd = GetDlgItem(IDC_URL);
	VERIFY(pWnd != NULL);
	CFont* pFont = pWnd->GetFont();
	VERIFY(pFont != NULL);
	LOGFONT lf;
	VERIFY(pFont->GetLogFont(&lf));
	lf.lfUnderline = TRUE; 
	VERIFY(m_fontURL.CreateFontIndirect(&lf));
	pWnd->SetFont(&m_fontURL);
	m_hWndUrl = pWnd->GetSafeHwnd();
	VERIFY(m_hWndUrl != NULL);
	::SetClassLong(m_hWndUrl, GCL_HCURSOR, (LONG)m_hcursor);  

	// MAIL font
	pWnd = GetDlgItem(IDC_EMAIL);
	VERIFY(pWnd != NULL);
	pFont = pWnd->GetFont();
	VERIFY(pFont != NULL);
	VERIFY(pFont->GetLogFont(&lf));
	lf.lfUnderline = TRUE; 
	VERIFY(m_fontMAIL.CreateFontIndirect(&lf));
	pWnd->SetFont(&m_fontMAIL);
	m_hWndMail = pWnd->GetSafeHwnd();
	VERIFY(m_hWndMail != NULL);
	::SetClassLong(m_hWndMail, GCL_HCURSOR, (LONG)m_hcursor);  
	
	return TRUE;  // return TRUE unless you set the focus to a control
	              // EXCEPTION: OCX Property Pages should return FALSE
}

void CAboutDlg::OnDestroy() 
{
	CDialog::OnDestroy();
	m_fontURL.DeleteObject();	
	m_fontMAIL.DeleteObject();
	if (m_hcursor != NULL)
	{
		DestroyCursor(m_hcursor);
		m_hcursor = NULL;
	}
}

void CAboutDlg::OnUrl() 
{
	CString strURL;
	GetDlgItemText(IDC_URL, strURL);
	ShellExecute(NULL, _T("open"), LPCTSTR(strURL), NULL, NULL, SW_SHOWMAXIMIZED); 
}

void CAboutDlg::OnEmail() 
{
	CString strMAIL;
	GetDlgItemText(IDC_EMAIL, strMAIL);
	ShellExecute(NULL, _T("open"), LPCTSTR(strMAIL), NULL, NULL, SW_SHOWMAXIMIZED); 
}

HBRUSH CAboutDlg::OnCtlColor(CDC* pDC, CWnd* pWnd, UINT nCtlColor) 
{
	HWND hWnd = pWnd->GetSafeHwnd();
	if (hWnd == m_hWndUrl || hWnd == m_hWndMail)
	{
		HBRUSH hbr = CDialog::OnCtlColor(pDC, pWnd, nCtlColor);
		pDC->SetTextColor( m_clrUrlText );
		pDC->SetBkColor( m_clrUrlBkgnd );
		return hbr;
	}
	else
		return NULL;
}
