// URLChecker.h : main header file for the URLCHECKER application
//

#if !defined(AFX_URLCHECKER_H__1F81C707_67B4_11D4_9F50_009027A4D0CE__INCLUDED_)
#define AFX_URLCHECKER_H__1F81C707_67B4_11D4_9F50_009027A4D0CE__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

#ifndef __AFXWIN_H__
	#error include 'stdafx.h' before including this file for PCH
#endif

#include "resource.h"       // main symbols

/////////////////////////////////////////////////////////////////////////////
// CURLCheckerApp:
// See URLChecker.cpp for the implementation of this class
//

#define WM_USER_PROGRESS_START			(WM_USER + 110)
#define WM_USER_PROGRESS_END			(WM_USER + 120)
#define WM_USER_PROGRESS_SHOW			(WM_USER + 130)
#define WM_USER_UPDATE_STATE			(WM_USER + 140)

#define SUCCESSFUL			0
#define PRESTARTSTATE		1
#define NOTVALIDINFO		2
#define STOPEDBYUSER		3

#define SLEEPMS				100


typedef struct _ThreadInfo
{
	LPVOID pDoc;
	time_t start;
	double elapsed_time;
	long nCurItem;
	int nSuspendIndex;
	UINT nExitCode;
	HWND hwndNotify;
	HANDLE m_hEventProgressStop;
	HANDLE m_hEventProgressStoped;
} ThreadInfo, *pThreadInfo;

UINT CheckThreadProc(LPVOID pParam);

class CURLCheckerApp : public CWinApp
{
public:
	CURLCheckerApp();

// Overrides
	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CURLCheckerApp)
	public:
	virtual BOOL InitInstance();
	virtual int ExitInstance();
	//}}AFX_VIRTUAL
	
	ThreadInfo m_ThreadInfo;
	CWinThread* m_pWinTread;
	BOOL m_bAutoSizeColumns;
	BOOL m_bAutoScroll;
	BOOL m_bAsynchronous;
	int m_nTimeOut;
	BOOL m_bIsChange;
	void StopProgress();
	void CheckUrls(int nItemUpdate = (-1)); 

// Implementation
	//{{AFX_MSG(CURLCheckerApp)
	afx_msg void OnAppAbout();
	afx_msg void OnOptionsStop();
	afx_msg void OnUpdateOptionsStop(CCmdUI* pCmdUI);
	afx_msg void OnOptionsStart();
	afx_msg void OnUpdateOptionsStart(CCmdUI* pCmdUI);
	afx_msg void OnOptionsContinue();
	afx_msg void OnUpdateOptionsContinue(CCmdUI* pCmdUI);
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};


/////////////////////////////////////////////////////////////////////////////

//{{AFX_INSERT_LOCATION}}
// Microsoft Visual C++ will insert additional declarations immediately before the previous line.

#endif // !defined(AFX_URLCHECKER_H__1F81C707_67B4_11D4_9F50_009027A4D0CE__INCLUDED_)
