// URLCheckerView.h : interface of the CURLCheckerView class
//
/////////////////////////////////////////////////////////////////////////////

#if !defined(AFX_URLCHECKERVIEW_H__1F81C70F_67B4_11D4_9F50_009027A4D0CE__INCLUDED_)
#define AFX_URLCHECKERVIEW_H__1F81C70F_67B4_11D4_9F50_009027A4D0CE__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

struct COLUMNINFO
{
	LPCTSTR lpszCaption;
	int nWidth;
};

class CURLCheckerView : public CListView
{
protected: // create from serialization only
	CURLCheckerView();
	DECLARE_DYNCREATE(CURLCheckerView)

// Attributes
public:
	CURLCheckerDoc* GetDocument();
	CListCtrl* m_pListCtrl;
	HWND m_hWndList;
// Operations
public:

// Overrides
	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CURLCheckerView)
	public:
	virtual void OnDraw(CDC* pDC);  // overridden to draw this view
	virtual BOOL PreCreateWindow(CREATESTRUCT& cs);
	virtual BOOL Create(LPCTSTR lpszClassName, LPCTSTR lpszWindowName, DWORD dwStyle, const RECT& rect, CWnd* pParentWnd, UINT nID, CCreateContext* pContext = NULL);
	protected:
	virtual void OnInitialUpdate(); // called first time after construct
	virtual BOOL OnPreparePrinting(CPrintInfo* pInfo);
	virtual void OnBeginPrinting(CDC* pDC, CPrintInfo* pInfo);
	virtual void OnEndPrinting(CDC* pDC, CPrintInfo* pInfo);
	virtual void OnUpdate(CView* pSender, LPARAM lHint, CObject* pHint);
	//}}AFX_VIRTUAL

// Implementation
public:
	void DeleteAllItems();
	virtual ~CURLCheckerView();
#ifdef _DEBUG
	virtual void AssertValid() const;
	virtual void Dump(CDumpContext& dc) const;
#endif

protected:
	static COLUMNINFO m_columns[];

// Generated message map functions
protected:
	BOOL IsColumns();
	BOOL AddColumns();
	//{{AFX_MSG(CURLCheckerView)
	afx_msg void OnSize(UINT nType, int cx, int cy);
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

#ifndef _DEBUG  // debug version in URLCheckerView.cpp
inline CURLCheckerDoc* CURLCheckerView::GetDocument()
   { return (CURLCheckerDoc*)m_pDocument; }
#endif

/////////////////////////////////////////////////////////////////////////////

//{{AFX_INSERT_LOCATION}}
// Microsoft Visual C++ will insert additional declarations immediately before the previous line.

#endif // !defined(AFX_URLCHECKERVIEW_H__1F81C70F_67B4_11D4_9F50_009027A4D0CE__INCLUDED_)
