// UrlObj.cpp : implementation file
//

#include "stdafx.h"
#include "URLChecker.h"
#include "UrlObj.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CUrlObj

int CUrlObj::m_nCheckIndex = 7;

LPCTSTR CUrlObj::m_pszStates[] =
{
	_T("Undefined"),
	_T("Success"),
	_T("Information"),
	_T("Requesr error"),
	_T("Server error"),
	_T("Time out"),
	_T("Aborted"),
	_T("Checking..."),
};


IMPLEMENT_DYNCREATE(CUrlObj, CCmdTarget)

CUrlObj::CUrlObj() : m_nState(UNDEFINED), m_nItem(-1), m_dwStatusCode(0)
{
}

CUrlObj::CUrlObj(int nCode, LPCTSTR lpszURL, LPCTSTR lpszDescription, HWND hWndList) :
	m_nCode(nCode), m_strURL(lpszURL), m_strDes(lpszDescription), m_nState(UNDEFINED), m_nItem(-1), m_dwStatusCode(0)
{
	if (hWndList != NULL)
		AddToListView(hWndList);
}

CUrlObj::~CUrlObj()
{
}


BEGIN_MESSAGE_MAP(CUrlObj, CCmdTarget)
	//{{AFX_MSG_MAP(CUrlObj)
		// NOTE - the ClassWizard will add and remove mapping macros here.
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CUrlObj message handlers

void CUrlObj::Serialize(CArchive& ar) 
{
	if (ar.IsStoring())
	{	// storing code
		ar << m_nCode;
		ar << m_strURL;
		ar << m_strDes;
		ar << m_nState;
		ar << m_dwStatusCode;
	}
	else
	{	// loading code
		ar >> m_nCode;
		ar >> m_strURL;
		ar >> m_strDes;
		ar >> m_nState;
		ar >> m_dwStatusCode;
	}
}

BOOL CUrlObj::AddToListView(HWND hWndList)
{
	if (hWndList != NULL)
	{
		_TCHAR szCode[10];
		_stprintf(szCode, _T("%d"), m_nCode);
		
		LVITEM item;
		item.mask = LVIF_TEXT;
		item.pszText = szCode;
		item.iSubItem = 0;
		item.iItem = ListView_GetItemCount(hWndList);
		int nItem = ListView_InsertItem(hWndList, &item);
		VERIFY(nItem != -1);
		
		ListView_SetItemText(hWndList, nItem, 1, (LPTSTR)LPCTSTR(m_strURL)); 
		ListView_SetItemText(hWndList, nItem, 2, (LPTSTR)LPCTSTR(m_strDes)); 
		ListView_SetItemText(hWndList, nItem, 3, (LPTSTR)LPCTSTR(m_pszStates[m_nState])); 
		
		m_nItem = nItem;
		return TRUE;
	}
	return FALSE;
}

void CUrlObj::UpdateState(HWND hWndList, int nType, BOOL bAutoScroll)
{
	if (hWndList == NULL)
		return ;
	
	if (m_nItem == -1)
		return ;
	
	// State from StatusCode
	if (m_nState != ABORTED && m_nState != TIME_OUT)
	{
		// Reset State from StatusCode
		if (200 <= m_dwStatusCode && m_dwStatusCode <= 299)
			m_nState = SUCCESS;
		else if (300 <= m_dwStatusCode && m_dwStatusCode <= 399)
			m_nState = INFORMATION;
		else if (400 <= m_dwStatusCode && m_dwStatusCode <= 499)
			m_nState = REQUEST_ERROR;
		else if (500 <= m_dwStatusCode && m_dwStatusCode <= 599)
			m_nState = SERVER_ERROR;
		else
			m_nState = UNDEFINED;
	}

	// Show State
	if (nType != 0)
	{
		ListView_SetItemText(hWndList, m_nItem, 3, (LPTSTR)LPCTSTR(m_pszStates[m_nState]));
	}
	else
	{
		ListView_SetItemText(hWndList, m_nItem, 3, (LPTSTR)LPCTSTR(m_pszStates[m_nCheckIndex]));
	}
	if (bAutoScroll)
		ListView_EnsureVisible(hWndList, m_nItem, FALSE);
}

LPCTSTR CUrlObj::GetState(int nState)
{
	if (-1 < nState &&  nState <= m_nCheckIndex)
		return m_pszStates[nState];
	else
		return _T("");
}
